//------------------------------------------------------------------------------
// <auto-generated />
//
// This file was automatically generated by SWIG (http://www.swig.org).
// Version 3.0.12
//
// Do not make changes to this file unless you know what you are doing--modify
// the SWIG interface file instead.
//------------------------------------------------------------------------------

namespace OpenMMNET {

public class VariableLangevinIntegrator : Integrator {
  private global::System.Runtime.InteropServices.HandleRef swigCPtr;

  internal VariableLangevinIntegrator(global::System.IntPtr cPtr, bool cMemoryOwn) : base(OpenMMSwigPINVOKE.VariableLangevinIntegrator_SWIGUpcast(cPtr), cMemoryOwn) {
    swigCPtr = new global::System.Runtime.InteropServices.HandleRef(this, cPtr);
  }

  internal static global::System.Runtime.InteropServices.HandleRef getCPtr(VariableLangevinIntegrator obj) {
    return (obj == null) ? new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero) : obj.swigCPtr;
  }

  ~VariableLangevinIntegrator() {
    Dispose();
  }

  public override void Dispose() {
    lock(this) {
      if (swigCPtr.Handle != global::System.IntPtr.Zero) {
        if (swigCMemOwn) {
          swigCMemOwn = false;
          OpenMMSwigPINVOKE.delete_VariableLangevinIntegrator(swigCPtr);
        }
        swigCPtr = new global::System.Runtime.InteropServices.HandleRef(null, global::System.IntPtr.Zero);
      }
      global::System.GC.SuppressFinalize(this);
      base.Dispose();
    }
  }

  public VariableLangevinIntegrator(double temperature, double frictionCoeff, double errorTol) : this(OpenMMSwigPINVOKE.new_VariableLangevinIntegrator(temperature, frictionCoeff, errorTol), true) {
  }

  public double getTemperature() {
    double ret = OpenMMSwigPINVOKE.VariableLangevinIntegrator_getTemperature(swigCPtr);
    return ret;
  }

  public void setTemperature(double temp) {
    OpenMMSwigPINVOKE.VariableLangevinIntegrator_setTemperature(swigCPtr, temp);
  }

  public double getFriction() {
    double ret = OpenMMSwigPINVOKE.VariableLangevinIntegrator_getFriction(swigCPtr);
    return ret;
  }

  public void setFriction(double coeff) {
    OpenMMSwigPINVOKE.VariableLangevinIntegrator_setFriction(swigCPtr, coeff);
  }

  public double getErrorTolerance() {
    double ret = OpenMMSwigPINVOKE.VariableLangevinIntegrator_getErrorTolerance(swigCPtr);
    return ret;
  }

  public void setErrorTolerance(double tol) {
    OpenMMSwigPINVOKE.VariableLangevinIntegrator_setErrorTolerance(swigCPtr, tol);
  }

  public int getRandomNumberSeed() {
    int ret = OpenMMSwigPINVOKE.VariableLangevinIntegrator_getRandomNumberSeed(swigCPtr);
    return ret;
  }

  public void setRandomNumberSeed(int seed) {
    OpenMMSwigPINVOKE.VariableLangevinIntegrator_setRandomNumberSeed(swigCPtr, seed);
  }

  public override void step(int steps) {
    OpenMMSwigPINVOKE.VariableLangevinIntegrator_step(swigCPtr, steps);
  }

  public void stepTo(double time) {
    OpenMMSwigPINVOKE.VariableLangevinIntegrator_stepTo(swigCPtr, time);
  }

}

}
